
clear all

for dtry = 1:10
    
    % % % fix random seeds
    
    seed = randi(1e8);
%     seed = 94458485;
    
    % fprintf('seed: %d\n', seed);
    if exist('RandStream','file')
        RandStream.setGlobalStream(RandStream('mt19937ar','seed',seed));
    else
        rand('state',seed); randn('state',seed);
    end
    
    m = 5000;
    n = 2000;
    k = 100;
    sp = 0.3;

    % create sparse matrix A
    np = round(sp*m*n);
    p = randperm(m*n); idx = p(1:np);
    A = zeros(m,n); A(idx) = rand(np,1); A = sparse(A);
    
    % create dense matrix B
    B = rand(n,k);
    tic; X1 = A*B; t1 = toc;
    tic; X2 = sfmult(A, B, 1); t2 = toc;
    err1 = norm(X1-X2,1);
    
    fprintf('seed: %9d, A*B: err %3.2e, matlab-cpu: %.2f, mkl-cpu: %.2f\n', ...
        seed, err1, t1, t2);
    
%     % create dense matrix B
%     B = rand(m,k);
%     tic; X1 = A'*B; t3 = toc;
%     %tic; X2 = sfmult(A', B, 1); t4 = toc;
%     tic; X2 = sfmult(A, B, 2); t4 = toc;
%     err2 = norm(X1-X2,1);
%     
%     fprintf('seed: %9d, A*B: err %3.2e, matlab-cpu: %.2f, mkl-cpu: %.2f, A''*B: err %3.2e, matlab-cpu: %.2f, mkl-cpu: %.2f\n', ...
%         seed, err1, t1, t2, err2, t3, t4);
    
end

